 /*
  * Khoros: $Id$
  */

 /*
  * $Log$
  */

/*
 * Copyright (C) 1993, 1994, 1995, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */


/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>>
   >>>>       Purpose: #defines for graphics attributes that
   >>>>                control the axis mode (linear, log, ln).
   >>>>
   >>>>    Written By: John Salas, Danielle Argiro, Mark Young
   >>>>
   >>>>          Date: Aug 20, 1994
   >>>>
   >>>> Modifications:
   >>>>
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */

#ifndef _xvisual_GraphicsAxisMode_h_
#define _xvisual_GraphicsAxisMode_h_

	/*-------------------------------------*
	|       #defines 
	---------------------------------------*/

/*------------------------------------------------------------------------
| Attribute:    XVW_GRAPHICS_MODE_X
| Description:  Whether the X Axis is marked as linear or log 10 scale.
| Type:         int
| Default:      .symbol index KGRAPHICS_LINEAR
| Legal Values: .symbol index KGRAPHICS_LINEAR
|               .symbol index KGRAPHICS_LOG10
| Resource:     graphicsModeX
------------------------------------------------------------------------*/
#define XVW_GRAPHICS_MODE_X             "graphicsModeX"

/*------------------------------------------------------------------------
| Attribute:    XVW_GRAPHICS_MODE_Y
| Description:  Whether the Y Axis is marked as linear or log 10 scale.
| Type:         int
| Default:      .symbol index KGRAPHICS_LINEAR
| Legal Values: .symbol index KGRAPHICS_LINEAR
|               .symbol index KGRAPHICS_LOG10
| Resource:     graphicsModeY
------------------------------------------------------------------------*/
#define XVW_GRAPHICS_MODE_Y             "graphicsModeY"

/*------------------------------------------------------------------------
| Attribute:    XVW_GRAPHICS_MODE_Z
| Description:  Whether the Z Axis is marked as linear or log 10 scale.
| Type:         int
| Default:      .symbol index KGRAPHICS_LINEAR
| Legal Values: .symbol index KGRAPHICS_LINEAR
|               .symbol index KGRAPHICS_LOG10
| Resource:     graphicsModeZ
------------------------------------------------------------------------*/
#define XVW_GRAPHICS_MODE_Z             "graphicsModeZ"

#endif /* _xvisual_GraphicsAxisMode_h_ */
/* Don't add after this point */
