 /*
  * Khoros: $Id$
  */

 /*
  * $Log$
  */

/*
 * Copyright (C) 1993, 1994, 1995, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */


/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>>
   >>>>       Purpose: #defines and #includes for creating a
   >>>>		       graphical line annotation.
   >>>>
   >>>>    Written By: John Salas and Mark Young
   >>>>
   >>>>          Date: Aug 05, 1992 14:22
   >>>>
   >>>> Modifications:
   >>>>
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */

#ifndef _xvisual_Line_h_
#define _xvisual_Line_h_


    /*-------------------------------------*
    |       #defines 
    ---------------------------------------*/

/*
 *  Attribute definitions for Line Visual Object
 */

/*------------------------------------------------------------------------
| Attribute:     XVW_LINE_XBEGIN
| Description:   .include $DESIGN/manual/shared/xvisual/line/LineXBegin.sec
| Type:          double
| Default:       0.0
| Legal Values:  any double world coordinate value
| Resource:      N/A
------------------------------------------------------------------------*/
#define XVW_LINE_XBEGIN	"lineXbegin"

/*------------------------------------------------------------------------
| Attribute:     XVW_LINE_YBEGIN
| Description:   .include $DESIGN/manual/shared/xvisual/line/LineYBegin.sec
| Type:          double
| Default:       0.0
| Legal Values:  any double world coordinate value
| Resource:      N/A
------------------------------------------------------------------------*/
#define XVW_LINE_YBEGIN	"lineYbegin"

/*------------------------------------------------------------------------
| Attribute:     XVW_LINE_XEND
| Description:   .include $DESIGN/manual/shared/xvisual/line/LineXEnd.sec
| Type:          double
| Default:       1.0
| Legal Values:  any double world coordinate value
| Resource:      N/A
------------------------------------------------------------------------*/
#define XVW_LINE_XEND	"lineXend"

/*------------------------------------------------------------------------
| Attribute:     XVW_LINE_YEND
| Description:   .include $DESIGN/manual/shared/xvisual/line/LineYEnd.sec
| Type:          double
| Default:       1.0
| Legal Values:  any double world coordinate value
| Resource:      N/A
------------------------------------------------------------------------*/
#define XVW_LINE_YEND	"lineYend"

/*
 *  Define the Class name, by which people should be externally referencing
 *  the Line Object by.
 */
#define LineGadgetClass	xvwLineGadgetClass

    /*-------------------------------------*
    |       global variable declarations
    ---------------------------------------*/

/*
 *  XToolkit Widget Declaration for LineGadgetClass
 */
extern   WidgetClass     LineGadgetClass;


    /*-------------------------------------*
    |       routine definitions
    ---------------------------------------*/

/*
 *  Function definitions for Line Visual Object
 */
xvobject xvw_create_line PROTO((xvobject, char *));


#endif /* _xvisual_Line_h_ */
/* Don't add after this point */
